| 導購 | 订阅 | 在线投稿
分享
 
 
 

JavaScript中try...catch和异常处理

2008-08-08 06:10:17  編輯來源:互聯網  简体版  手機版  評論  字體: ||
 
  在JavaScript可以使用try...catch来进行异常处理。例如: try {

   foo.bar();

  } catch (e) {

   alert(e.name + " : " + e.message);

  }

  

  目前我们可能得到的系统异常主要包含以下6种:

  EvalError: raised when an error occurs executing code in eval()

  RangeError: raised when a numeric variable or parameter is outside of its valid range

  ReferenceError: raised when de-referencing an invalid reference

  SyntaxError: raised when a syntax error occurs while parsing code in eval()

  TypeError: raised when a variable or parameter is not a valid type

  URIError: raised when encodeURI() or decodeURI() are passed invalid parameters

  上面的六种异常对象都继承自Error对象。他们都支持以下两种构造方法:

  new Error();

  new Error( " 异常信息 " );

  手工抛出异常的方法如下:

   try {

   throw new Error( " Whoops! " );

  } catch (e) {

   alert(e.name + " : " + e.message);

  }

  如要判断异常信息的类型,可在catch中进行判断:

  try {

   foo.bar();

  } catch (e) {

   if (e instanceof EvalError) {

   alert(e.name + " : " + e.message);

   } else if (e instanceof RangeError) {

   alert(e.name + " : " + e.message);

   }

   // etc

  }

  Error具有下面一些主要属性:

  description: 错误描述 (仅IE可用).

  fileName: 出错的文件名 (仅Mozilla可用).

  lineNumber: 出错的行数 (仅Mozilla可用).

  message: 错误信息 (在IE下同description)

  name: 错误类型.

  number: 错误代码 (仅IE可用).

  stack: 像Java中的Stack Trace一样的错误堆栈信息 (仅Mozilla可用).

  因此为了更好的了解错误信息我们可以将catch部分改为如下形式:

   try {

   foo.bar();

  } catch (e) {

   if (browserType != BROWSER_IE) {

   alert(

   " name: " + e.name +

   " \nmessage: " + e.message +

   " \nlineNumber: " + e.lineNumber +

   " \nfileName: " + e.fileName +

   " \nstack: " + e.stack);

   }

   else {

   alert(

   " name: " + e.name +

   " \nerrorNumber: " + (e.number & 0xFFFF ) +

   " \nmessage: " + e.message " );

   }

  }

  JavaScript中的throw命令事实上可以抛出任何对象,并且我们可以在catch接受到此对象。例如:

  1 try {

  2 throw new Date(); // 抛出当前时间对象

  3 } catch (e) {

  4 alert(e.toLocaleString()); // 使用本地格式显示当前时间

  5 }
 
 
 
在JavaScript可以使用try...catch来进行异常处理。例如: try { foo.bar(); } catch (e) { alert(e.name + " : " + e.message); } 目前我们可能得到的系统异常主要包含以下6种: EvalError: raised when an error occurs executing code in eval() RangeError: raised when a numeric variable or parameter is outside of its valid range ReferenceError: raised when de-referencing an invalid reference SyntaxError: raised when a syntax error occurs while parsing code in eval() TypeError: raised when a variable or parameter is not a valid type URIError: raised when encodeURI() or decodeURI() are passed invalid parameters 上面的六种异常对象都继承自Error对象。他们都支持以下两种构造方法: new Error(); new Error( " 异常信息 " ); 手工抛出异常的方法如下: try { throw new Error( " Whoops! " ); } catch (e) { alert(e.name + " : " + e.message); } 如要判断异常信息的类型,可在catch中进行判断: try { foo.bar(); } catch (e) { if (e instanceof EvalError) { alert(e.name + " : " + e.message); } else if (e instanceof RangeError) { alert(e.name + " : " + e.message); } // etc } Error具有下面一些主要属性: description: 错误描述 (仅IE可用). fileName: 出错的文件名 (仅Mozilla可用). lineNumber: 出错的行数 (仅Mozilla可用). message: 错误信息 (在IE下同description) name: 错误类型. number: 错误代码 (仅IE可用). stack: 像Java中的Stack Trace一样的错误堆栈信息 (仅Mozilla可用). 因此为了更好的了解错误信息我们可以将catch部分改为如下形式: try { foo.bar(); } catch (e) { if (browserType != BROWSER_IE) { alert( " name: " + e.name + " \nmessage: " + e.message + " \nlineNumber: " + e.lineNumber + " \nfileName: " + e.fileName + " \nstack: " + e.stack); } else { alert( " name: " + e.name + " \nerrorNumber: " + (e.number & 0xFFFF ) + " \nmessage: " + e.message " ); } } JavaScript中的throw命令事实上可以抛出任何对象,并且我们可以在catch接受到此对象。例如: 1 try { 2 throw new Date(); // 抛出当前时间对象 3 } catch (e) { 4 alert(e.toLocaleString()); // 使用本地格式显示当前时间 5 }
󰈣󰈤
 
 
 
>>返回首頁<<
 
 
 
 
 
 熱帖排行
 
 
王朝网络微信公众号
微信扫码关注本站公众号 wangchaonetcn
 
  免责声明:本文仅代表作者个人观点,与王朝网络无关。王朝网络登载此文出于传递更多信息之目的,并不意味著赞同其观点或证实其描述,其原创性以及文中陈述文字和内容未经本站证实,对本文以及其中全部或者部分内容、文字的真实性、完整性、及时性本站不作任何保证或承诺,请读者仅作参考,并请自行核实相关内容。
 
© 2005- 王朝網路 版權所有